/**
 * Copyright (c) 2022 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#include "assert.h"
#include <stdarg.h>

void assertTrueImplement(
  const char *file,
  const int32_t line,
  const char *func,
  const bool_t result,
  const char *message,
  ...
) {
  if(result) return;

  // Print file info.
  fprintf(
    stderr,
    "Assert failed in %s:%i :: %s\n",
    file,
    line,
    func
  );

  // Print message.
  va_list args;
  va_start(args, message);
  vfprintf(stderr, message, args);
  va_end(args);
  fprintf(stderr, "\n");
  abort();
}
